# № 9371 Джобс 10.06.23 (Уровень: Сложный)
# Алгоритм вычисления значения функции F(n), где n – натуральное число,
# задан следующими соотношениями:
# F(n)=1 , если n≥3210,
# G(n)=n, если n<10.
# F(n)=F(n+3)+7, если n<3210,
# G(n)=G(n−3)+5, если n≥10.
# Чему равно значение выражения F(15)−G(3000)?

from functools import lru_cache
# Модуль functools содержит весьма полезный декоратор под названием
# lru_cache.
# Этот декоратор «оборачивает функцию вызываемым запоминанием,
# которое сохраняет максимальное количество всех последних вызовов«.
@lru_cache(None) # Этот декоратор можно использовать для кэширования
                 # результатов функции, так что последующие вызовы
                 # функции с теми же аргументами не будут выполняться
                 # снова.
def f(n):
    if n>=3210:
        return 1
    if n<3210:
        return f(n+3)+7
def g(n):
    if n<10:
        return n
    if n>=10:
        return g(n-3)+5
for i in range (3210,15,-1):
    f(i)
for i in range (10,3210):
    f(i)
print(f(15)-g(3000))
